package com.app.keyboard.colorful

//import com.pretty.keyboard.theme.keyboard.helper.ObjectBox

import android.app.Application
import android.content.Intent
import android.graphics.Typeface
import androidx.localbroadcastmanager.content.LocalBroadcastManager
import com.app.keyboard.colorful.data.ChildBean
import com.app.keyboard.colorful.data.ClassBean
import com.applovin.sdk.AppLovinMediationProvider
import com.applovin.sdk.AppLovinSdk
import com.applovin.sdk.AppLovinSdkInitializationConfiguration
import org.json.JSONArray
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.io.StringWriter


class MyApp : Application() {
    companion object {
        lateinit var myAppInstance: MyApp

        lateinit var list: MutableList<ClassBean>

        const val TAG = "-----------------"
        var defaultFont: Typeface? = null
        const val DB_VERSION = 1
        const val DB_NAME = "db_name"
        var initSDkOK = false
        var initAction = "ACTION_INIT"
    }

    override fun onCreate() {
        super.onCreate()
        myAppInstance = this
        defaultFont = Typeface.createFromAsset(assets, "font.ttf")
        initMAxSDk()
        dealFile()


    }

    private fun dealFile() {
        val openFile = myAppInstance.assets.open("data.json")
        val jsonString = getJsonString(openFile)
        if (jsonString != null) {
            resolveJsonString(jsonString)
        }
    }


    private fun resolveJsonString(string: String) {
        val jsonData = JSONArray(string)
        var dataList: MutableList<ClassBean> = mutableListOf()
        for (i in 0 until jsonData.length()) {
            jsonData.getJSONObject(i).run {
                val pName = getString("parent_name")
                val listArray = getJSONArray("keyboard_list")
                var childBeanList: MutableList<ChildBean> = mutableListOf()
                for (listIndex in 0 until listArray.length()) {
                    listArray.getJSONObject(listIndex).also {
                        val title = it.getString("title")
                        val thUrl = it.getString("thumbUrl")
                        val thGif = it.getString("thumbUrlGif")
                        var zipPath = ""
                        var imgPath = ""
                        var imgGif = ""
                        var imgPreviewGif = ""
                        if (it.has("detail")) {
                            val contentObject =
                                it.getJSONObject("detail").getJSONObject("themeContent")
                            zipPath = contentObject.getString("androidRawZipUrl")
                            imgPath = contentObject.getString("img")
                            imgGif = contentObject.getString("imgGif")
                            imgPreviewGif = contentObject.getString("imgPreviewGif")
                        } else {

                        }
                        childBeanList.add(
                            ChildBean().apply {
                            setImgPath(imgPath)
                            setZipPath(zipPath)
                            setTitleName(title)
                            setImgGif(imgGif)
                            thumbUrl = thUrl
                            thumbGif = thGif
                        })

                    }

                }
                val shuffled = childBeanList.shuffled()
                val dataClassBean = ClassBean()
                    .apply {
                    parentName = pName
                    keyboardList = shuffled
                }
                dataList.add(dataClassBean)

            }
        }

        updateDataList(dataList)

    }

    private fun updateDataList(mainList: MutableList<ClassBean>) {
        list = mainList

    }
    private fun getJsonString(fileInputStream: InputStream): String? {
        return try {
            val charArray = CharArray(fileInputStream.available())
            var readCount = 0
            val streamReader = InputStreamReader(fileInputStream)
            val bufferedReader = BufferedReader(streamReader)
            val stringWriter = StringWriter()
            while (bufferedReader.read(charArray).also { readCount = it } != -1) {
                stringWriter.write(charArray, 0, readCount)
            }
            stringWriter.toString()
        } catch (e: IOException) {
            ""
        }
    }



    private val SDK_KEY = "yhOU4TgSF10NVhdOBNZy6VbUxFc25c78nh_LA3905OB6rHVXJdsa0DVUhsIA6DWqJaHKDkimoBWXD5CktvrVXg"
    private fun initMAxSDk() {
        val initConfig = AppLovinSdkInitializationConfiguration.builder(SDK_KEY, this)
            .setMediationProvider(AppLovinMediationProvider.MAX)
            .build()
        AppLovinSdk.getInstance(this).initialize(initConfig) {
            initSDkOK = true
            LocalBroadcastManager.getInstance(this@MyApp).sendBroadcast(Intent(initAction))
        }
    }


}